git-tar-tree: no more void pointer arithmetic
[git.git] / git-merge-one-file.sh
index 5419e59..5619409 100755 (executable)
@@ -25,7 +25,8 @@ case "${1:-.}${2:-.}${3:-.}" in
                echo "Removing $4"
        fi
        if test -f "$4"; then
-               rm -f -- "$4"
+               rm -f -- "$4" &&
+               rmdir -p "$(expr "z$4" : 'z\(.*\)/')" 2>/dev/null || :
        fi &&
                exec git-update-index --remove -- "$4"
        ;;
@@ -40,7 +41,7 @@ case "${1:-.}${2:-.}${3:-.}" in
        ;;
 
 #
-# Added in both (check for same permissions).
+# Added in both, identically (check for same permissions).
 #
 ".$3$2")
        if [ "$6" != "$7" ]; then
@@ -56,26 +57,57 @@ case "${1:-.}${2:-.}${3:-.}" in
 #
 # Modified in both, but differently.
 #
-"$1$2$3")
-       echo "Auto-merging $4."
-       orig=`git-unpack-file $1`
+"$1$2$3" | ".$2$3")
+
+       case ",$6,$7," in
+       *,120000,*)
+               echo "ERROR: $4: Not merging symbolic link changes."
+               exit 1
+               ;;
+       esac
+
        src2=`git-unpack-file $3`
+       case "$1" in
+       '')
+               echo "Added $4 in both, but differently."
+               # This extracts OUR file in $orig, and uses git-apply to
+               # remove lines that are unique to ours.
+               orig=`git-unpack-file $2`
+               sz0=`wc -c <"$orig"`
+               diff -u -La/$orig -Lb/$orig $orig $src2 | git-apply --no-add 
+               sz1=`wc -c <"$orig"`
+
+               # If we do not have enough common material, it is not
+               # worth trying two-file merge using common subsections.
+               expr "$sz0" \< "$sz1" \* 2 >/dev/null || : >$orig
+               ;;
+       *)
+               echo "Auto-merging $4"
+               orig=`git-unpack-file $1`
+               ;;
+       esac
 
-       # We reset the index to the first branch, making
-       # git-diff-file useful
-       git-update-index --add --cacheinfo "$6" "$2" "$4"
-               git-checkout-index -u -f -- "$4" &&
-               merge "$4" "$orig" "$src2"
+       # Be careful for funny filename such as "-L" in "$4", which
+       # would confuse "merge" greatly.
+       src1=`git-unpack-file $2`
+       merge "$src1" "$orig" "$src2"
        ret=$?
-       rm -f -- "$orig" "$src2"
+
+       # Create the working tree file, using "our tree" version from the
+       # index, and then store the result of the merge.
+       git-checkout-index -f --stage=2 -- "$4" && cat "$src1" >"$4"
+       rm -f -- "$orig" "$src1" "$src2"
 
        if [ "$6" != "$7" ]; then
                echo "ERROR: Permissions conflict: $5->$6,$7."
                ret=1
        fi
+       if [ "$1" = '' ]; then
+               ret=1
+       fi
 
        if [ $ret -ne 0 ]; then
-               echo "ERROR: Merge conflict in $4."
+               echo "ERROR: Merge conflict in $4"
                exit 1
        fi
        exec git-update-index -- "$4"